// This module is a edge detection which is uesd to the async signals
module asyncsig_edge_detect ( 
    input       async_sig,
    input       clk,
    output reg  sig_risedge,
    output reg  sig_faledge);

    reg [2:0]   resync_ff = 3'b000;

    always @(posedge clk) begin
        // detect rising and falling edges.
        sig_risedge <= ~resync_ff[2] &  resync_ff[1];
        sig_faledge <=  resync_ff[2] & ~resync_ff[1];
        // update history shifter.
        resync_ff   <= {resync_ff[1:0], async_sig};
    end
    
endmodule
