//*********************************************************************
// This is a FAN speed control logic with PWM
//
// sam.lin@gfec.com.tw, GALAXY TW
// History :
// 08-29-14  Created
//
//*********************************************************************
`include "../top/es7632bt_fanpld_defined.vh"

module fan_pwm (
    input           MGMT_CLK,
    input           MGMT_RST_N,
    input  [3:0]    PWM_CNTR,
    input  [3:0]    FAN_PWM,
    output          FAN_CONTROL
);

    // Signals for this Design
    reg [3:0] r_fan_pwm = 4'd4;
    reg [3:0] pwm_progress;

    // Buffers
    wire   clock   = MGMT_CLK;
    wire   reset_n = MGMT_RST_N;
    assign FAN_CONTROL = (PWM_CNTR <= r_fan_pwm);

    // Register
    always @(posedge clock) begin
        if (!reset_n) begin
            r_fan_pwm <= `DEFAULT_PWM;
        end else begin
        	r_fan_pwm <= FAN_PWM;
        end
    end

endmodule
